#include "Common.ch"
#include "Inkey.ch"

PROCEDURE Main

LOCAL wi:={}
LOCAL nEvent, mp1, mp2, oXbp
LOCAL aMenus:={}, aSubMenus:={}, cMenu:=""
LOCAL oSession
LOCAL cConnStr

PUBLIC oCrt
PUBLIC oMenuBar
PUBLIC lAppRun := .t.               // Programm beenden, wenn .F.
PUBLIC farbe0:= ""   // := SETCOLOR() nach MyAppSys()
PUBLIC farbe1:= "BG+/B, GR+/BG,, GR+/B, N/BG"
PUBLIC farbe2:= "N/BG, GR+/W,,, N/W"
PUBLIC farbe3:= "W+/BG, GR+/W,,, N/W"
PUBLIC farbe4:= "N/W, GR+/BG,,, N/BG"
PUBLIC farbe5:= "W+/RB"
PUBLIC farbe6:= "GR+/W"
PUBLIC farbe7:= "GR+/BG"
PUBLIC farbe8:= "W+/BG, W+/N, GR+/BG, W+/N, N+/W, N/BG"     // Men
PUBLIC cFontFile:="FONT.BIN"
PUBLIC AppMaxRow:=50
PUBLIC AppMaxCol:=79

MyAppSys()

DbeLoad("pgdbe")
DbeSetDefault("pgdbe")

cConnStr := "DBE=pgdbe;server=localhost;"
cConnStr += "db=mdidemo;uid=postgres;pwd=postgres

oSession := DacSession():New(cConnStr)
IF(!oSession:IsConnected())
    MsgBox("Verbindung fehlgeschlagen ("+Var2Char(oSession:GetLastMessage())+")")
    QUIT
ENDIF

SET DELETED ON

oMenuBar:=MenuCreate(farbe8)          // Hauptmenaufruf
oCrt:setTitle("BrowserTest")
aMenus := DC_MM_aMenus(oMenuBar)
aSubMenus := DC_MM_aSubMenus(oMenuBar)

WHILE lAppRun
    KEYBOARD ""    // Clear buffer to avoid possible ESC loop
    cMenu := DC_MENUMAIN( { 0, 2, "N/BG,W+/BG,GR+/BG,W+/N,N+/W", 'AAD', ;
                            .t., cMenu, ;
                            aMenus, aSubMenus, ;
                            '', .f., 0, 0, {}, .f., ;
                            {MAXROW(),0,0,MAXROW(),0,MAXROW(),MAXCOL()} } )
END

Quit_App()

RETURN


FUNC MenuCreate(cFarbe1)
LOCAL oTopBar, oPopUp

oTopBar := TopBar( 0, 2, 62)
oTopBar:ColorSpec := cFarbe1

oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1
oPopUp:AddItem(MenuItem( "&Browser Test" ,{|| BrowseBT() },,;
                         "Browser Test Table",1))
oTopBar:AddItem( MenuItem ( "&Tables",oPopUp) )

oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1
oPopUp:AddItem(MenuItem( "&Insert" ,{|| InsertData() },,;
                         "Insert Test Data",2))
oTopBar:AddItem( MenuItem ( "&Insert",oPopUp) )

oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1
oPopUp:AddItem(MenuItem( "&End" ,{|| lAppRun := .f. },,;
                         "End Program", 999))
oTopBar:AddItem( MenuItem ( "&End" + SPACE(AppMaxCol-75), oPopUp) )

RETURN oTopBar


/*
 * Routine zum Beenden eines Programms
 */
PROCEDURE Quit_App()

COMMIT
CLOSE ALL
#ifdef USE_POSTGRES
// Immer die Verbindung(en) zum Server beenden.
AEval( DacSession():sessionList(), {|o|o:disconnect()})
#endif
QUIT

RETURN


**************
PROC BrowseBT()
LOCAL wi:={}, aft:=""
PRIVATE funcbl:={|| btfu()}, browsebl:={|| btbr()}

USE BRTEST NEW

aft:=futa({})
upn("BrowserTest")
DBGOTOP()
wi:=swopen(1,0,AppMaxRow-1,AppMaxCol)
sibrowse()
swclose(wi)
restfuta(aft)

CLOSE BRTEST

RETURN


***********
PROC btbr()
browse:addColumn(TBColumnNew("F1", {|| F1 } ))
browse:addColumn(TBColumnNew("F2", {|| F2 } ))
RETURN


***********
PROC btfu()
DO CASE
    CASE nKey==K_ESC            //Tabelle schlieen
        lMore:=.f.
END
RETURN


**************
PROC InsertData()
LOCAL nRecs:=10000, nStart:=0, i:=0, s:="", wi:={}

USE BRTEST NEW

wi:=swopen(10,24,14,55,"Insert Test Data",farbe3)
DISPBEGIN()
SETCURSOR(1)
SETCOLOR(farbe2)
@ 1,0 SAY "Number of records:" GET nRecs PICTURE "99999"
DISPEND()
READ
swclose(wi)

IF nRecs > 0 .AND. LASTKEY() != K_ESC
    COUNT TO nStart
    FOR i := nStart + 1 TO nStart + nRecs
        s := PADL(LTRIM(STR(i)), 5, "0")
        MyAppend()
        BRTEST->F1 := "F1-" + s
        BRTEST->F2 := "F2-" + s
    NEXT
END

CLOSE BRTEST

RETURN

